
#include <globjects/base/StaticStringSource.h>


namespace globjects
{


StaticStringSource::StaticStringSource(const std::string & string)
: m_string(string)
{
}

StaticStringSource::StaticStringSource(std::string && string)
    : m_string(std::move(string))
{
}

StaticStringSource::StaticStringSource(const char * data, const size_t length)
: m_string(data, length)
{
}

std::string StaticStringSource::shortInfo() const
{
    return "<static string>";
}

std::string StaticStringSource::string() const
{
    return m_string;
}

void StaticStringSource::setString(const std::string & string)
{
    m_string = string;

    changed();
}

void StaticStringSource::setString(std::string && string)
{
    m_string = std::move(string);

    changed();
}


} // namespace globjects
