
import QtQuick 2.0

import QmlToolbox.Controls 1.0
import QmlToolbox.PropertyEditor 1.0


/**
*  Category
*
*  Container for a category of controls
*/
Item
{
    id: item

    property string title: ''
    property bool   contentVisible: true
    property int    contentHeight: 0

    property alias properties:     propertyEditor.properties
    property alias path:           propertyEditor.path
    property alias categoryFilter: propertyEditor.categoryFilter
    property alias compact:        propertyEditor.compact
    property alias lineSpacing:    propertyEditor.lineSpacing

    implicitWidth:  200
    implicitHeight: column.implicitHeight

    clip: true

    Column
    {
        id: column

        anchors.left:  parent.left
        anchors.right: parent.right

        Title
        {
            width: parent.width

            text: item.title

            onClicked:
            {
                item.contentVisible = !item.contentVisible

                propertyEditor.update();
            }
        }

        PropertyEditor
        {
            id: propertyEditor

            width:  parent.width
            height: item.contentVisible ? implicitHeight : 0

            visible: item.contentVisible

            properties:     item.properties
            path:           item.path
            categoryFilter: item.categoryFilter

            Behavior on height
            {
                PropertyAnimation { }
            }
        }
    }

    function update()
    {
        propertyEditor.update();
    }
}
