
function setCamera(template)
{
    if (template == 'default') {
        gloperate.canvas0.setValue('root.Trackball', 'pitch', -50.8509);
        gloperate.canvas0.setValue('root.Trackball', 'yaw', 97.2092);
        gloperate.canvas0.setValue('root.Trackball', 'zoom', 0.0185266);
        gloperate.canvas0.setValue('root.Trackball', 'rotateX', -157.0);
        gloperate.canvas0.setValue('root.Trackball', 'rotateY', -57.1);
    }

    if (template == 'closeup') {
        gloperate.canvas0.setValue('root.Trackball', 'pitch', -51.0363);
        gloperate.canvas0.setValue('root.Trackball', 'yaw', 97.4947);
        gloperate.canvas0.setValue('root.Trackball', 'zoom', 0.0156626);
        gloperate.canvas0.setValue('root.Trackball', 'rotateX', -63.7999);
        gloperate.canvas0.setValue('root.Trackball', 'rotateY', -60.8);
    }

    if (template == 'stc') {
        gloperate.canvas0.setValue('root.Trackball', 'pitch', -51.339);
        gloperate.canvas0.setValue('root.Trackball', 'yaw', 97.7704);
        gloperate.canvas0.setValue('root.Trackball', 'zoom', 0.0317365);
        gloperate.canvas0.setValue('root.Trackball', 'rotateX', -34.2);
        gloperate.canvas0.setValue('root.Trackball', 'rotateY', -74.5);
    }

    if (template == 'density') {
        gloperate.canvas0.setValue('root.Trackball', 'pitch', -50.8509);
        gloperate.canvas0.setValue('root.Trackball', 'yaw', 97.2092);
        gloperate.canvas0.setValue('root.Trackball', 'zoom', 0.0185266);
        gloperate.canvas0.setValue('root.Trackball', 'rotateX', -155.2);
        gloperate.canvas0.setValue('root.Trackball', 'rotateY', -31.9);
    }
}

function setTimeSpan(template)
{
    var minTime = gloperate.canvas0.getValue('root.TemporalFilter', 'minTime');
    var maxTime = gloperate.canvas0.getValue('root.TemporalFilter', 'maxTime');

    if (template == 'default') {
        var begin = minTime;
        var end   = minTime + (maxTime - minTime) * 0.5;

        gloperate.canvas0.setValue('root.TemporalFilter', 'minTime1', begin);
        gloperate.canvas0.setValue('root.TemporalFilter', 'maxTime1', end);
        gloperate.canvas0.setValue('root.TemporalFilter', 'minTime2', begin);
        gloperate.canvas0.setValue('root.TemporalFilter', 'maxTime2', end);
    }

    if (template == 'small') {
        var begin = minTime + (maxTime - minTime) * 0.9;
        var end   = maxTime;

        gloperate.canvas0.setValue('root.TemporalFilter', 'minTime1', begin);
        gloperate.canvas0.setValue('root.TemporalFilter', 'maxTime1', end);
        gloperate.canvas0.setValue('root.TemporalFilter', 'minTime2', begin);
        gloperate.canvas0.setValue('root.TemporalFilter', 'maxTime2', end);
    }

    if (template == 'small2') {
        var begin = minTime + (maxTime - minTime) * 0.7;
        var end   = minTime + (maxTime - minTime) * 0.8;

        gloperate.canvas0.setValue('root.TemporalFilter', 'minTime1', begin);
        gloperate.canvas0.setValue('root.TemporalFilter', 'maxTime1', end);
        gloperate.canvas0.setValue('root.TemporalFilter', 'minTime2', begin);
        gloperate.canvas0.setValue('root.TemporalFilter', 'maxTime2', end);
    }

    else if (template == 'one') {
        var begin = minTime;
        var end   = minTime + (maxTime - minTime) * 0.3;

        gloperate.canvas0.setValue('root.TemporalFilter', 'minTime1', begin);
        gloperate.canvas0.setValue('root.TemporalFilter', 'maxTime1', end);
        gloperate.canvas0.setValue('root.TemporalFilter', 'minTime2', end);
        gloperate.canvas0.setValue('root.TemporalFilter', 'maxTime2', end);
    }

    else if (template == 'two') {
        var begin1 = minTime;
        var end1   = minTime + (maxTime - minTime) * 0.15;
        var begin2 = minTime + (maxTime - minTime) * 0.25;
        var end2   = minTime + (maxTime - minTime) * 0.6;

        gloperate.canvas0.setValue('root.TemporalFilter', 'minTime1', begin1);
        gloperate.canvas0.setValue('root.TemporalFilter', 'maxTime1', end1);
        gloperate.canvas0.setValue('root.TemporalFilter', 'minTime2', begin2);
        gloperate.canvas0.setValue('root.TemporalFilter', 'maxTime2', end2);
    }
}

function setConfigTemplate(configId, template)
{
    setCamera('default');
    setTimeSpan('default');

    var stage = 'root.Trajectories.config' + configId;

    if (template == 'lines') {
        gloperate.canvas0.setValue(stage, 'geometryType', 'Tubes');
        gloperate.canvas0.setValue(stage, 'tessellation', 16.0);
        gloperate.canvas0.setValue(stage, 'texture', 'tube_texture_none.png');
        gloperate.canvas0.setValue(stage, 'colorMap', 'color_gradient_blue');
        gloperate.canvas0.setValue(stage, 'mapHeight', 'Node - height');
        gloperate.canvas0.setValue(stage, 'height', 0.0);
        gloperate.canvas0.setValue(stage, 'mapRadius', 'None');
        gloperate.canvas0.setValue(stage, 'radius', 0.0);
        gloperate.canvas0.setValue(stage, 'mapColor', 'None');
        gloperate.canvas0.setValue(stage, 'color', 0.5);
        gloperate.canvas0.setValue(stage, 'mapAlpha', 'None');
        gloperate.canvas0.setValue(stage, 'alpha', 1.0);
        gloperate.canvas0.setValue(stage, 'mapTextureX', 'Node - length');
        gloperate.canvas0.setValue(stage, 'textureX', 0.0);
        gloperate.canvas0.setValue(stage, 'mapTextureY', 'None');
        gloperate.canvas0.setValue(stage, 'textureY', 0.0);
        gloperate.canvas0.setValue(stage, 'minRadius', 0.00001);
        gloperate.canvas0.setValue(stage, 'maxRadius', 0.00001);
        gloperate.canvas0.setValue(stage, 'sizeOfSingleStretch', 1.0);
        gloperate.canvas0.setValue(stage, 'sizeOfSingleTorsion', 1.0);
        gloperate.canvas0.setValue(stage, 'animationSpeed', 1.0);
    }

    if (template == 'tubes') {
        gloperate.canvas0.setValue(stage, 'geometryType', 'Tubes');
        gloperate.canvas0.setValue(stage, 'tessellation', 16.0);
        gloperate.canvas0.setValue(stage, 'texture', 'tube_texture_arrow.png');
        gloperate.canvas0.setValue(stage, 'colorMap', 'color_gradient_blue');
        gloperate.canvas0.setValue(stage, 'mapHeight', 'Node - height');
        gloperate.canvas0.setValue(stage, 'height', 0.0);
        gloperate.canvas0.setValue(stage, 'mapRadius', 'None');
        gloperate.canvas0.setValue(stage, 'radius', 0.5);
        gloperate.canvas0.setValue(stage, 'mapColor', 'None');
        gloperate.canvas0.setValue(stage, 'color', 0.5);
        gloperate.canvas0.setValue(stage, 'mapAlpha', 'None');
        gloperate.canvas0.setValue(stage, 'alpha', 1.0);
        gloperate.canvas0.setValue(stage, 'mapTextureX', 'Node - length');
        gloperate.canvas0.setValue(stage, 'textureX', 0.0);
        gloperate.canvas0.setValue(stage, 'mapTextureY', 'None');
        gloperate.canvas0.setValue(stage, 'textureY', 0.0);
        gloperate.canvas0.setValue(stage, 'minRadius', 0.000015);
        gloperate.canvas0.setValue(stage, 'maxRadius', 0.00008);
        gloperate.canvas0.setValue(stage, 'sizeOfSingleStretch', 1.0);
        gloperate.canvas0.setValue(stage, 'sizeOfSingleTorsion', 1.0);
        gloperate.canvas0.setValue(stage, 'animationSpeed', 1.0);
    }

    if (template == 'spheres') {
        gloperate.canvas0.setValue(stage, 'geometryType', 'Spheres');
        gloperate.canvas0.setValue(stage, 'tessellation', 16.0);
        gloperate.canvas0.setValue(stage, 'texture', 'tube_texture_arrow.png');
        gloperate.canvas0.setValue(stage, 'colorMap', 'color_gradient_blue');
        gloperate.canvas0.setValue(stage, 'mapHeight', 'Node - height');
        gloperate.canvas0.setValue(stage, 'height', 0.0);
        gloperate.canvas0.setValue(stage, 'mapRadius', 'None');
        gloperate.canvas0.setValue(stage, 'radius', 0.5);
        gloperate.canvas0.setValue(stage, 'mapColor', 'None');
        gloperate.canvas0.setValue(stage, 'color', 0.5);
        gloperate.canvas0.setValue(stage, 'mapAlpha', 'None');
        gloperate.canvas0.setValue(stage, 'alpha', 1.0);
        gloperate.canvas0.setValue(stage, 'mapTextureX', 'Node - length');
        gloperate.canvas0.setValue(stage, 'textureX', 0.0);
        gloperate.canvas0.setValue(stage, 'mapTextureY', 'None');
        gloperate.canvas0.setValue(stage, 'textureY', 0.0);
        gloperate.canvas0.setValue(stage, 'minRadius', 0.000045);
        gloperate.canvas0.setValue(stage, 'maxRadius', 0.000065);
        gloperate.canvas0.setValue(stage, 'sizeOfSingleStretch', 1.0);
        gloperate.canvas0.setValue(stage, 'sizeOfSingleTorsion', 1.0);
        gloperate.canvas0.setValue(stage, 'animationSpeed', 1.0);
    }

    if (template == 'detail') {
        gloperate.canvas0.setValue(stage, 'geometryType', 'Tubes');
        gloperate.canvas0.setValue(stage, 'tessellation', 16.0);
        gloperate.canvas0.setValue(stage, 'texture', 'tube_texture_arrow.png');
        gloperate.canvas0.setValue(stage, 'colorMap', 'color_gradient_rev');
        gloperate.canvas0.setValue(stage, 'mapHeight', 'Node - height');
        gloperate.canvas0.setValue(stage, 'height', 0.0);
        gloperate.canvas0.setValue(stage, 'mapRadius', 'None');
        gloperate.canvas0.setValue(stage, 'radius', 1.0);
        gloperate.canvas0.setValue(stage, 'mapColor', 'Node - acceleration');
        gloperate.canvas0.setValue(stage, 'color', 0.5);
        gloperate.canvas0.setValue(stage, 'mapAlpha', 'None');
        gloperate.canvas0.setValue(stage, 'alpha', 1.0);
        gloperate.canvas0.setValue(stage, 'mapTextureX', 'Node - length');
        gloperate.canvas0.setValue(stage, 'textureX', 0.0);
        gloperate.canvas0.setValue(stage, 'mapTextureY', 'None');
        gloperate.canvas0.setValue(stage, 'textureY', 0.0);
        gloperate.canvas0.setValue(stage, 'minRadius', 0.000015);
        gloperate.canvas0.setValue(stage, 'maxRadius', 0.00005);
        gloperate.canvas0.setValue(stage, 'sizeOfSingleStretch', 1.0);
        gloperate.canvas0.setValue(stage, 'sizeOfSingleTorsion', 1.0);
        gloperate.canvas0.setValue(stage, 'animationSpeed', 1.0);
    }
}

function setConfiguration(id)
{
    gloperate.canvas0.setValue('root', 'trajectoriesVisible', true);
    gloperate.canvas0.setValue('root', 'densityMapVisible',   false);
    gloperate.canvas0.setValue('root.Picking', 'radius', 1);
    gloperate.canvas0.setValue('root.Trajectories', 'temporalFocusContext', false);

    // (a) Lines
    if (id == 0) {
        gloperate.canvas0.setValue('root', 'primaryAttribute', 'Zero');
        gloperate.canvas0.setValue('root.Trajectories', 'selectedID', -1);
        gloperate.canvas0.setValue('root.Trajectories', 'showHelpers', true);

        setConfigTemplate('1', 'lines');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'mapColor', 'Node - height');

        setConfigTemplate('2', 'lines');

        setConfigTemplate('3', 'lines');

        setConfigTemplate('4', 'lines');

        setConfigTemplate('Hover', 'detail');
    }

    // (b) Tubes (velocity)
    else if (id == 1) {
        gloperate.canvas0.setValue('root', 'primaryAttribute', 'Zero');
        gloperate.canvas0.setValue('root.Trajectories', 'selectedID', -1);
        gloperate.canvas0.setValue('root.Trajectories', 'showHelpers', true);

        setConfigTemplate('1', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'colorMap', 'color_gradient_rev');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'mapColor', 'Node - velocity');

        setConfigTemplate('2', 'tubes');

        setConfigTemplate('3', 'tubes');

        setConfigTemplate('4', 'tubes');

        setConfigTemplate('Hover', 'detail');
    }

    // (c) Tubes (acceleration)
    else if (id == 2) {
        gloperate.canvas0.setValue('root', 'primaryAttribute', 'Zero');
        gloperate.canvas0.setValue('root.Trajectories', 'selectedID', -1);
        gloperate.canvas0.setValue('root.Trajectories', 'showHelpers', true);

        setConfigTemplate('1', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'colorMap', 'color_gradient_rev');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'mapColor', 'Node - acceleration');

        setConfigTemplate('2', 'tubes');

        setConfigTemplate('3', 'tubes');

        setConfigTemplate('4', 'tubes');

        setConfigTemplate('Hover', 'detail');
    }

    // (d) Spheres (velocity)
    else if (id == 3) {
        gloperate.canvas0.setValue('root', 'primaryAttribute', 'Zero');
        gloperate.canvas0.setValue('root.Trajectories', 'selectedID', -1);
        gloperate.canvas0.setValue('root.Trajectories', 'showHelpers', true);

        setConfigTemplate('1', 'spheres');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'colorMap', 'color_gradient_rev');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'mapColor', 'Node - velocity');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'mapRadius', 'Node - velocity');

        setConfigTemplate('2', 'spheres');

        setConfigTemplate('3', 'spheres');

        setConfigTemplate('4', 'spheres');

        setConfigTemplate('Hover', 'detail');
    }

    // (e) Tubes (arriving/departing)
    else if (id == 4) {
        gloperate.canvas0.setValue('root', 'primaryAttribute', 'Line - flighttype');
        gloperate.canvas0.setValue('root.Trajectories', 'selectedID', -1);
        gloperate.canvas0.setValue('root.Trajectories', 'showHelpers', false);

        setConfigTemplate('1', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'colorMap', 'color_gradient_blue');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'mapColor', 'Node - velocity');

        setConfigTemplate('2', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'colorMap', 'color_gradient_red');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'mapColor', 'Node - velocity');

        setConfigTemplate('3', 'tubes');

        setConfigTemplate('4', 'tubes');

        setConfigTemplate('Hover', 'detail');
    }

    // (f) Tubes (weight class)
    else if (id == 5) {
        gloperate.canvas0.setValue('root', 'primaryAttribute', 'Line - weightClass');
        gloperate.canvas0.setValue('root.Trajectories', 'selectedID', -1);
        gloperate.canvas0.setValue('root.Trajectories', 'showHelpers', true);

        setConfigTemplate('1', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'texture', 'tube_texture_none.png');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'colorMap', 'color_gradient_rev');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'mapColor', 'None');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'color', 0.0);
        gloperate.canvas0.setValue('root.Trajectories.config1', 'radius', 0.0);

        setConfigTemplate('2', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'texture', 'tube_texture_none.png');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'colorMap', 'color_gradient_rev');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'mapColor', 'None');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'color', 0.3);
        gloperate.canvas0.setValue('root.Trajectories.config2', 'radius', 0.3);

        setConfigTemplate('3', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config3', 'texture', 'tube_texture_none.png');
        gloperate.canvas0.setValue('root.Trajectories.config3', 'colorMap', 'color_gradient_rev');
        gloperate.canvas0.setValue('root.Trajectories.config3', 'mapColor', 'None');
        gloperate.canvas0.setValue('root.Trajectories.config3', 'color', 0.7);
        gloperate.canvas0.setValue('root.Trajectories.config3', 'radius', 0.7);

        setConfigTemplate('4', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config4', 'texture', 'tube_texture_none.png');
        gloperate.canvas0.setValue('root.Trajectories.config4', 'colorMap', 'color_gradient_rev');
        gloperate.canvas0.setValue('root.Trajectories.config4', 'mapColor', 'None');
        gloperate.canvas0.setValue('root.Trajectories.config4', 'color', 1.0);
        gloperate.canvas0.setValue('root.Trajectories.config4', 'radius', 1.0);

        setConfigTemplate('Hover', 'detail');
    }

    // (g) Tubes (arriving/departing) and selection
    else if (id == 6) {
        gloperate.canvas0.setValue('root', 'primaryAttribute', 'Line - flighttype');
        gloperate.canvas0.setValue('root.Trajectories', 'selectedID', 679);
        gloperate.canvas0.setValue('root.Trajectories', 'showHelpers', true);

        setConfigTemplate('1', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'colorMap', 'color_gradient_blue');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'mapColor', 'Node - velocity');

        setConfigTemplate('2', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'colorMap', 'color_gradient_red');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'mapColor', 'Node - velocity');

        setConfigTemplate('3', 'tubes');

        setConfigTemplate('4', 'tubes');

        setConfigTemplate('Hover', 'detail');
    }

    // (h) Tubes (arriving/departing) and selection
    else if (id == 7) {
        gloperate.canvas0.setValue('root', 'primaryAttribute', 'Zero');
        gloperate.canvas0.setValue('root.Trajectories', 'selectedID', 1528);
        gloperate.canvas0.setValue('root.Trajectories', 'showHelpers', false);

        setConfigTemplate('1', 'lines');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'mapColor', 'Node - height');

        setConfigTemplate('2', 'lines');

        setConfigTemplate('3', 'lines');

        setConfigTemplate('4', 'lines');

        setConfigTemplate('Hover', 'detail');

        setTimeSpan('small2');

        setCamera('closeup');
    }

    // (i) Tubes (arriving/departing) and STC
    else if (id == 8) {
        gloperate.canvas0.setValue('root', 'primaryAttribute', 'Line - flighttype');
        gloperate.canvas0.setValue('root.Trajectories', 'selectedID', -1);
        gloperate.canvas0.setValue('root.Trajectories', 'showHelpers', true);

        setConfigTemplate('1', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'colorMap', 'color_gradient_blue');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'mapColor', 'Node - velocity');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'mapHeight', 'Node - time');

        setConfigTemplate('2', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'colorMap', 'color_gradient_red');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'mapColor', 'Node - velocity');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'mapHeight', 'Node - time');

        setConfigTemplate('3', 'tubes');

        setConfigTemplate('4', 'tubes');

        setConfigTemplate('Hover', 'detail');

        setTimeSpan('small');
        setCamera('stc');
    }

    // (j) Density map (1 time span)
    else if (id == 9) {
        gloperate.canvas0.setValue('root', 'trajectoriesVisible', false);
        gloperate.canvas0.setValue('root', 'densityMapVisible', true);
        setTimeSpan('one');
        setCamera('density');
    }

    // (k) Density map (2 time spans)
    else if (id == 10) {
        gloperate.canvas0.setValue('root', 'trajectoriesVisible', false);
        gloperate.canvas0.setValue('root', 'densityMapVisible', true);
        setTimeSpan('two');
        setCamera('density');
    }

    // (l) Spatial selection
    else if (id == 11) {
        gloperate.canvas0.setValue('root', 'primaryAttribute', 'Zero');
        gloperate.canvas0.setValue('root.Trajectories', 'selectedID', -1);
        gloperate.canvas0.setValue('root.Trajectories', 'showHelpers', false);
        gloperate.canvas0.setValue('root.Picking', 'radius', 50);

        setConfigTemplate('1', 'lines');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'mapColor', 'Node - height');

        setConfigTemplate('2', 'lines');

        setConfigTemplate('3', 'lines');

        setConfigTemplate('4', 'lines');

        setConfigTemplate('Hover', 'detail');
        gloperate.canvas0.setValue('root.Trajectories.configHover', 'colorMap', 'color_gradient_red');
    }

    // (m) Temporal focus and context
    else if (id == 12) {
        gloperate.canvas0.setValue('root', 'primaryAttribute', 'Line - flighttype');
        gloperate.canvas0.setValue('root.Trajectories', 'selectedID', -1);
        gloperate.canvas0.setValue('root.Trajectories', 'showHelpers', false);
        gloperate.canvas0.setValue('root.Trajectories', 'temporalFocusContext', true);

        setConfigTemplate('1', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'colorMap', 'color_gradient_blue');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'mapColor', 'Node - velocity');

        setConfigTemplate('2', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'colorMap', 'color_gradient_red');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'mapColor', 'Node - velocity');

        setConfigTemplate('3', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config3', 'colorMap', '0014_gradient_violet');
        gloperate.canvas0.setValue('root.Trajectories.config3', 'mapColor', 'Node - velocity');

        setConfigTemplate('4', 'tubes');

        setConfigTemplate('Hover', 'detail');
    }

    // (n) Tubes (arriving/departing) and density maps
    else if (id == 13) {
        gloperate.canvas0.setValue('root', 'primaryAttribute', 'Line - flighttype');
        gloperate.canvas0.setValue('root', 'densityMapVisible', true);
        gloperate.canvas0.setValue('root.Trajectories', 'selectedID', -1);
        gloperate.canvas0.setValue('root.Trajectories', 'showHelpers', false);

        setConfigTemplate('1', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'colorMap', 'color_gradient_blue');
        gloperate.canvas0.setValue('root.Trajectories.config1', 'mapColor', 'Node - velocity');

        setConfigTemplate('2', 'tubes');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'colorMap', 'color_gradient_red');
        gloperate.canvas0.setValue('root.Trajectories.config2', 'mapColor', 'Node - velocity');

        setConfigTemplate('3', 'tubes');

        setConfigTemplate('4', 'tubes');

        setConfigTemplate('Hover', 'detail');
    }

    // Default
    else {
        setConfiguration(0);
    }
}

function renderPerformanceTest()
{
    console.log('Measuring rendering performance');

    var configs = [
        { maxNodes: 100000, drawMode: 5 },
        { maxNodes:  10000, drawMode: 5 },
        { maxNodes:   1000, drawMode: 5 },
        { maxNodes: 100000, drawMode: 4 },
        { maxNodes:  10000, drawMode: 4 },
        { maxNodes:   1000, drawMode: 4 },
        { maxNodes: 100000, drawMode: 3 },
        { maxNodes:  10000, drawMode: 3 },
        { maxNodes:   1000, drawMode: 3 },
        { maxNodes: 100000, drawMode: 2 },
        { maxNodes:  10000, drawMode: 2 },
        { maxNodes:   1000, drawMode: 2 },
        { maxNodes: 100000, drawMode: 1 },
        { maxNodes:  10000, drawMode: 1 },
        { maxNodes:   1000, drawMode: 1 },
    ];

    var config = -1;
    var timer  = 0;

    var nextConfig = function()
    {
        if (config < configs.length - 1) {
            config++;

            gloperate.canvas0.setValue('root', 'drawMode', configs[config].drawMode);
            gloperate.canvas0.setValue('root', 'maxNodes', configs[config].maxNodes);
            gloperate.canvas0.setValue('root', 'measureRendering', !gloperate.canvas0.getValue('root', 'measureRendering'));

            return true;
        }

        return false;
    }

    var timerFunc = function()
    {
        var frame = gloperate.canvas0.getValue('root.Measurement', 'frame');
        if (frame >= 100) {
            if (!nextConfig())
            {
                gloperate.timer.stop(timer);
            }
        }
    };

    timer = gloperate.timer.start(1000, timerFunc);
}

function updatePerformanceTest()
{
    console.log('Measuring update performance');

    var configs = [
        { maxNodes: 100000, drawMode: 5 },
        { maxNodes:  10000, drawMode: 5 },
        { maxNodes:   1000, drawMode: 5 },
        { maxNodes: 100000, drawMode: 4 },
        { maxNodes:  10000, drawMode: 4 },
        { maxNodes:   1000, drawMode: 4 },
        { maxNodes: 100000, drawMode: 3 },
        { maxNodes:  10000, drawMode: 3 },
        { maxNodes:   1000, drawMode: 3 },
        { maxNodes: 100000, drawMode: 2 },
        { maxNodes:  10000, drawMode: 2 },
        { maxNodes:   1000, drawMode: 2 },
        { maxNodes: 100000, drawMode: 1 },
        { maxNodes:  10000, drawMode: 1 },
        { maxNodes:   1000, drawMode: 1 },
    ];

    var config = -1;
    var timer  = 0;

    var nextConfig = function()
    {
        if (config < configs.length - 1) {
            config++;

            gloperate.canvas0.setValue('root', 'drawMode', configs[config].drawMode);
            gloperate.canvas0.setValue('root', 'maxNodes', configs[config].maxNodes);
            gloperate.canvas0.setValue('root', 'measureUpdate', true);

            return true;
        }

        return false;
    };

    var timerFunc = function()
    {
        var frame = gloperate.canvas0.getValue('root.Trajectories', 'frame');
        if (frame >= 100) {
            if (!nextConfig())
            {
                gloperate.timer.stop(timer);
                gloperate.canvas0.setValue('root', 'measureUpdate', false);
            }
        }
    };

    timer = gloperate.timer.start(1000, timerFunc);
}

gloperate.input.onInput(function(device, type, key, modifier, button, x, y, wx, wy)
{
    if (device === 'keyboard' && type === 'ButtonRelease') {
        if (key == 49) { // '1'
            gloperate.canvas0.setValue('root', 'drawMode', 1);
        }

        else if (key == 50) { // '2'
            gloperate.canvas0.setValue('root', 'drawMode', 2);
        }

        else if (key == 51) { // '3'
            gloperate.canvas0.setValue('root', 'drawMode', 3);
        }

        else if (key == 52) { // '4'
            gloperate.canvas0.setValue('root', 'drawMode', 4);
        }

        else if (key == 53) { // '5'
            gloperate.canvas0.setValue('root', 'drawMode', 5);
        }

        else if (key == 48) { // '0'
            gloperate.canvas0.setValue('root', 'maxNodes', 0);
        }

        else if (key == 57) { // '9'
            gloperate.canvas0.setValue('root', 'maxNodes', 100000);
        }

        else if (key == 56) { // '8'
            gloperate.canvas0.setValue('root', 'maxNodes', 10000);
        }

        else if (key == 55) { // '7'
            gloperate.canvas0.setValue('root', 'maxNodes', 1000);
        }

        else if (key == 83) { // 'S'
            gloperate.canvas0.setValue('root.Screenshot', 'path', 'out.png');
        }

        else if (key == 84) { // 'T'
            renderPerformanceTest();
        }

        else if (key == 85) { // 'U'
            updatePerformanceTest();
        }

        else if (key >= 65 && key <= 81) { // 'A' .. 'Q'
            setConfiguration(key - 65);
        }
    }
});
