
function setCamera(template)
{
    if (template == 'default') {
        gloperate.canvas0.setValue('root.Trackball', 'pitch', -29.0);
        gloperate.canvas0.setValue('root.Trackball', 'yaw', 44.5);
        gloperate.canvas0.setValue('root.Trackball', 'zoom', 2.5);
        gloperate.canvas0.setValue('root.Trackball', 'rotateX', 0);
        gloperate.canvas0.setValue('root.Trackball', 'rotateY', 0);
    }

    else if (template == 'default2') {
        gloperate.canvas0.setValue('root.Trackball', 'pitch', -20.5);
        gloperate.canvas0.setValue('root.Trackball', 'yaw', 191.5);
        gloperate.canvas0.setValue('root.Trackball', 'zoom', 2.5);
        gloperate.canvas0.setValue('root.Trackball', 'rotateX', 0);
        gloperate.canvas0.setValue('root.Trackball', 'rotateY', 0);
    }

    else if (template == 'default3') {
        gloperate.canvas0.setValue('root.Trackball', 'pitch', -4.9237);
        gloperate.canvas0.setValue('root.Trackball', 'yaw', 16.5195);
        gloperate.canvas0.setValue('root.Trackball', 'zoom', 4.10362);
        gloperate.canvas0.setValue('root.Trackball', 'rotateX', 0);
        gloperate.canvas0.setValue('root.Trackball', 'rotateY', 0);
    }

    else if (template == 'africa') {
        gloperate.canvas0.setValue('root.Trackball', 'pitch', 1.05154);
        gloperate.canvas0.setValue('root.Trackball', 'yaw', 112.95);
        gloperate.canvas0.setValue('root.Trackball', 'zoom', 1.19326);
        gloperate.canvas0.setValue('root.Trackball', 'rotateX', 0);
        gloperate.canvas0.setValue('root.Trackball', 'rotateY', 0);
    }

    else if (template == 'germany') {
        gloperate.canvas0.setValue('root.Trackball', 'pitch', -50.9838);
        gloperate.canvas0.setValue('root.Trackball', 'yaw', 99.8929);
        gloperate.canvas0.setValue('root.Trackball', 'zoom', 0.190051);
        gloperate.canvas0.setValue('root.Trackball', 'rotateX', 0);
        gloperate.canvas0.setValue('root.Trackball', 'rotateY', 0);
    }

    else if (template == '2d') {
        gloperate.canvas0.setValue('root.Trackball', 'pitch', 46.5687);
        gloperate.canvas0.setValue('root.Trackball', 'yaw', -0.309372);
        gloperate.canvas0.setValue('root.Trackball', 'zoom', 1.15105);
        gloperate.canvas0.setValue('root.Trackball', 'rotateX', 0);
        gloperate.canvas0.setValue('root.Trackball', 'rotateY', 0);
    }
}

function setConfiguration(id)
{
    var filename = gloperate.canvas0.getValue('root', 'filename');

    // (a) Global climate network (unfiltered)
    if (id == 0) {
        if (filename !== '../datasets/ds1.dot') {
            gloperate.canvas0.setValue('root', 'filename', '../datasets/ds1.dot');
        }

        gloperate.canvas0.onRendered(function() {
            setCamera('default');

            gloperate.canvas0.setValue('root', 'projection', 'Geocentric');
            gloperate.canvas0.setValue('root', 'heightScale', 0.5);
            gloperate.canvas0.setValue('root', 'nodeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'edgeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'nodeScale', 1.0);
            gloperate.canvas0.setValue('root', 'nodeColor', 'Node - betweenness');
            gloperate.canvas0.setValue('root', 'edgeColor', 'Edge - edge_betweenness');
            gloperate.canvas0.setValue('root.Filter', 'node_betweenness', [0, 3590066.5]);
            gloperate.canvas0.setValue('root', 'unsharpMasking', false);
            gloperate.canvas0.setValue('root', 'unsharpFactor', 1.0);
        });
    }

    // (b) Global climate network (filtered by betweenness)
    else if (id == 1) {
        if (filename !== '../datasets/ds1.dot') {
            gloperate.canvas0.setValue('root', 'filename', '../datasets/ds1.dot');
        }

        gloperate.canvas0.onRendered(function() {
            setCamera('default');

            gloperate.canvas0.setValue('root', 'projection', 'Geocentric');
            gloperate.canvas0.setValue('root', 'heightScale', 0.5);
            gloperate.canvas0.setValue('root', 'nodeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'edgeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'nodeScale', 1.0);
            gloperate.canvas0.setValue('root', 'nodeColor', 'Node - betweenness');
            gloperate.canvas0.setValue('root', 'edgeColor', 'Edge - edge_betweenness');
            gloperate.canvas0.setValue('root.Filter', 'node_betweenness', [100000, 3590066.5]);
            gloperate.canvas0.setValue('root', 'unsharpMasking', false);
            gloperate.canvas0.setValue('root', 'unsharpFactor', 1.0);
        });
    }

    // (c) Regional climate network (Africa)
    else if (id == 2) {
        if (filename !== '../datasets/africanet_jul_0_75.dot') {
            gloperate.canvas0.setValue('root', 'filename', '../datasets/africanet_jul_0_75.dot');
        }

        gloperate.canvas0.onRendered(function() {
            setCamera('africa');

            gloperate.canvas0.setValue('root', 'projection', 'Geocentric');
            gloperate.canvas0.setValue('root', 'heightScale', 0.5);
            gloperate.canvas0.setValue('root', 'nodeColorMap', '0013_blue');
            gloperate.canvas0.setValue('root', 'edgeColorMap', '0013_blue');
            gloperate.canvas0.setValue('root', 'nodeScale', 0.2);
            gloperate.canvas0.setValue('root', 'nodeColor', 'Node - degree');
            gloperate.canvas0.setValue('root', 'nodeSize', 'Node - degree');
            gloperate.canvas0.setValue('root', 'edgeColor', 'Node - degree');
            gloperate.canvas0.setValue('root.Filter', 'node_betweenness', [5.0, 6.5]);
            gloperate.canvas0.setValue('root', 'unsharpMasking', true);
            gloperate.canvas0.setValue('root', 'unsharpFactor', 50.0);
        });
    }

    // (d) Local climate network (Germany)
    else if (id == 3) {
        if (filename !== '../datasets/germany_daily-tmit.dot') {
            gloperate.canvas0.setValue('root', 'filename', '../datasets/germany_daily-tmit.dot');
        }

        gloperate.canvas0.onRendered(function() {
            setCamera('germany');

            gloperate.canvas0.setValue('root', 'projection', 'Geocentric');
            gloperate.canvas0.setValue('root', 'heightScale', 0.5);
            gloperate.canvas0.setValue('root', 'nodeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'edgeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'nodeScale', 0.05);
            gloperate.canvas0.setValue('root', 'nodeColor', 'Node - degree');
            gloperate.canvas0.setValue('root', 'nodeSize', 'Node - degree');
            gloperate.canvas0.setValue('root', 'edgeColor', 'Node - betweenness');
            gloperate.canvas0.setValue('root.Filter', 'node_betweenness', [0, 6.5]);
            gloperate.canvas0.setValue('root', 'unsharpMasking', true);
            gloperate.canvas0.setValue('root', 'unsharpFactor', 25.0);
        });
    }

    // (e) Global climate network (3D)
    else if (id == 4) {
        if (filename !== '../datasets/ds1.dot') {
            gloperate.canvas0.setValue('root', 'filename', '../datasets/ds1.dot');
        }

        gloperate.canvas0.onRendered(function() {
            setCamera('default2');

            gloperate.canvas0.setValue('root', 'projection', 'Geocentric');
            gloperate.canvas0.setValue('root', 'heightScale', 0.5);
            gloperate.canvas0.setValue('root', 'nodeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'edgeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'nodeScale', 1.0);
            gloperate.canvas0.setValue('root', 'nodeColor', 'Node - betweenness');
            gloperate.canvas0.setValue('root', 'edgeColor', 'Edge - edge_betweenness');
            gloperate.canvas0.setValue('root.Filter', 'node_betweenness', [100000, 3590066.5]);
            gloperate.canvas0.setValue('root', 'unsharpMasking', false);
            gloperate.canvas0.setValue('root', 'unsharpFactor', 1.0);
        });
    }

    // (f) Global climate network (mercator)
    else if (id == 5) {
        if (filename !== '../datasets/ds1.dot') {
            gloperate.canvas0.setValue('root', 'filename', '../datasets/ds1.dot');
        }

        gloperate.canvas0.onRendered(function() {
            setCamera('2d');

            gloperate.canvas0.setValue('root', 'projection', 'Mercator');
            gloperate.canvas0.setValue('root', 'heightScale', 0.5);
            gloperate.canvas0.setValue('root', 'nodeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'edgeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'nodeScale', 1.0);
            gloperate.canvas0.setValue('root', 'nodeColor', 'Node - betweenness');
            gloperate.canvas0.setValue('root', 'edgeColor', 'Edge - edge_betweenness');
            gloperate.canvas0.setValue('root.Filter', 'node_betweenness', [100000, 3590066.5]);
            gloperate.canvas0.setValue('root', 'unsharpMasking', false);
            gloperate.canvas0.setValue('root', 'unsharpFactor', 1.0);
        });
    }

    // (g) Global climate network (transverse mercator)
    else if (id == 6) {
        if (filename !== '../datasets/ds1.dot') {
            gloperate.canvas0.setValue('root', 'filename', '../datasets/ds1.dot');
        }

        gloperate.canvas0.onRendered(function() {
            setCamera('2d');

            gloperate.canvas0.setValue('root', 'projection', 'Transverse Mercator');
            gloperate.canvas0.setValue('root', 'heightScale', 0.5);
            gloperate.canvas0.setValue('root', 'nodeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'edgeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'nodeScale', 1.0);
            gloperate.canvas0.setValue('root', 'nodeColor', 'Node - betweenness');
            gloperate.canvas0.setValue('root', 'edgeColor', 'Edge - edge_betweenness');
            gloperate.canvas0.setValue('root.Filter', 'node_betweenness', [100000, 3590066.5]);
            gloperate.canvas0.setValue('root', 'unsharpMasking', false);
            gloperate.canvas0.setValue('root', 'unsharpFactor', 1.0);
        });
    }

    // (h) Global climate network (360°)
    else if (id == 7) {
        if (filename !== '../datasets/ds1.dot') {
            gloperate.canvas0.setValue('root', 'filename', '../datasets/ds1.dot');
        }

        gloperate.canvas0.onRendered(function() {
            setCamera('2d');

            gloperate.canvas0.setValue('root', 'projection', '360 Degrees');
            gloperate.canvas0.setValue('root', 'heightScale', 0.5);
            gloperate.canvas0.setValue('root', 'nodeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'edgeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'nodeScale', 1.0);
            gloperate.canvas0.setValue('root', 'nodeColor', 'Node - betweenness');
            gloperate.canvas0.setValue('root', 'edgeColor', 'Edge - edge_betweenness');
            gloperate.canvas0.setValue('root.Filter', 'node_betweenness', [100000, 3590066.5]);
            gloperate.canvas0.setValue('root', 'unsharpMasking', false);
            gloperate.canvas0.setValue('root', 'unsharpFactor', 1.0);
        });
    }

    // (i) Global climate network (3D)
    else if (id == 8) {
        if (filename !== '../datasets/coupled_climate_network_T_0.5_levels_0_5.gml') {
            gloperate.canvas0.setValue('root', 'filename', '../datasets/coupled_climate_network_T_0.5_levels_0_5.gml');
        }

        gloperate.canvas0.onRendered(function() {
            setCamera('default3');

            gloperate.canvas0.setValue('root', 'projection', 'Geocentric');
            gloperate.canvas0.setValue('root', 'heightScale', 0.1);
            gloperate.canvas0.setValue('root', 'nodeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'edgeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'nodeScale', 1.0);
            gloperate.canvas0.setValue('root', 'nodeColor', 'Node - hgt_level');
            gloperate.canvas0.setValue('root', 'nodeHeight', 'Node - hgt_level');
            gloperate.canvas0.setValue('root', 'edgeColor', 'Node - hgt_level');
            gloperate.canvas0.setValue('root.Filter', 'edge_ang_dist',               [0, 3.14159]);
            gloperate.canvas0.setValue('root.Filter', 'node_cross_betweenness',      [7500, 110783]);
            gloperate.canvas0.setValue('root.Filter', 'node_cross_degree',           [0, 925]);
            gloperate.canvas0.setValue('root.Filter', 'node_cross_local_clustering', [0, 1]);
            gloperate.canvas0.setValue('root.Filter', 'node_hgt_level',              [0, 5.0]);
            gloperate.canvas0.setValue('root.Filter', 'edge_length',                 [0, 400]);
            gloperate.canvas0.setValue('root', 'unsharpMasking', false);
            gloperate.canvas0.setValue('root', 'unsharpFactor', 1.0);
        });
    }

    // (j) Global climate network (mercator)
    else if (id == 9) {
        if (filename !== '../datasets/coupled_climate_network_T_0.5_levels_0_5.gml') {
            gloperate.canvas0.setValue('root', 'filename', '../datasets/coupled_climate_network_T_0.5_levels_0_5.gml');
        }

        gloperate.canvas0.onRendered(function() {
            setCamera('2d');

            gloperate.canvas0.setValue('root', 'projection', 'Mercator');
            gloperate.canvas0.setValue('root', 'heightScale', 0.1);
            gloperate.canvas0.setValue('root', 'nodeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'edgeColorMap', '0005_hsv_saturation_orange');
            gloperate.canvas0.setValue('root', 'nodeScale', 1.0);
            gloperate.canvas0.setValue('root', 'nodeColor', 'Node - hgt_level');
            gloperate.canvas0.setValue('root', 'nodeHeight', 'Node - hgt_level');
            gloperate.canvas0.setValue('root', 'edgeColor', 'Node - hgt_level');
            gloperate.canvas0.setValue('root.Filter', 'edge_ang_dist',               [0, 3.14159]);
            gloperate.canvas0.setValue('root.Filter', 'node_cross_betweenness',      [7500, 110783]);
            gloperate.canvas0.setValue('root.Filter', 'node_cross_degree',           [0, 925]);
            gloperate.canvas0.setValue('root.Filter', 'node_cross_local_clustering', [0, 1]);
            gloperate.canvas0.setValue('root.Filter', 'node_hgt_level',              [0, 5.0]);
            gloperate.canvas0.setValue('root.Filter', 'edge_length',                 [0, 400]);
            gloperate.canvas0.setValue('root', 'unsharpMasking', false);
            gloperate.canvas0.setValue('root', 'unsharpFactor', 1.0);
        });
    }
}

gloperate.input.onInput(function(device, type, key, modifier, button, x, y, wx, wy)
{
    if (device === 'keyboard' && type === 'ButtonRelease') {
        if (key >= 65 && key <= 81) { // 'A' .. 'Q'
            setConfiguration(key - 65);
        }
    }
});
