
// Wait for GTX to initialize
gloperate.timer.once(1500, function() {

    // Load dataset
    console.log('Loading dataset');
    gloperate.canvas0.setValue('root', 'filename', 'datasets/multiscale/multiscale.adjmat');

    // When loaded, set visualization options
    gloperate.canvas0.onRendered(function() {
        console.log('Setting options');

        // Set camera
        gloperate.canvas0.setValue('root.Trackball', 'pitch',  -29.0);
        gloperate.canvas0.setValue('root.Trackball', 'yaw',     44.5);
        gloperate.canvas0.setValue('root.Trackball', 'zoom',    2.5);
        gloperate.canvas0.setValue('root.Trackball', 'rotateX', 0);
        gloperate.canvas0.setValue('root.Trackball', 'rotateY', 0);

        // Map edge length to color
        gloperate.canvas0.setValue('root', 'edgeColor', 'Edge - length');

        // Select first layer
        var layer = 0;
        gloperate.canvas0.setValue('root.Filter', 'node_layer', [layer, layer + 0.9]);

        // Define keyboard shortcuts
        gloperate.input.onInput(function(device, type, key, modifier, button, x, y, wx, wy)
        {
            // Key press event
            if (device === 'keyboard' && type === 'ButtonRelease') {
                // Key ','
                if (key == 44) {
                    // Decrease layer
                    layer = Math.max(layer - 1, 0);

                    // Update filter
                    console.log('Layer ' + layer);
                    gloperate.canvas0.setValue('root.Filter', 'node_layer', [layer, layer + 0.9]);
                }

                // Key '.'
                if (key == 46) {
                    // Increase layer
                    layer = Math.min(layer + 1, 7);
                    gloperate.canvas0.setValue('root.Filter', 'node_layer', [layer, layer + 0.9]);

                    // Update filter
                    console.log('Layer ' + layer);
                }
            }
        });
    });

});
