
#version 330


// Uniforms
uniform sampler2D gradient;

// Color helpers
vec3 hue(float h)
{
    float r = abs(h * 6 - 3) - 1;
    float g = 2 - abs(h * 6 - 2);
    float b = 2 - abs(h * 6 - 4);
    return clamp(vec3(r, g, b), 0.0, 1.0);
}

vec4 fromHSV(vec3 hsv)
{
    return vec4(((hue(hsv.x) - 1.0) * hsv.y + 1.0) * hsv.z, 1.0);
}

// Map value (0..1) to color, using the given color map texture
vec4 mapColor(float v)
{    
//  return fromHSV(vec3(v, 1.0, 1.0));
    return texture(gradient, vec2(clamp(v, 0.0, 1.0), 0.0));
}

vec4 mapToColor(in sampler2D map, float v)
{    
    return texture(map, vec2(clamp(v, 0.0, 1.0), 0.0));
}
