
#version 330


// Uniforms
uniform sampler2D      worldTexture;
uniform sampler2DArray mapLayersTexture;


// Imported functions
float normalizedTime1();


// Get world color
vec4 worldColor(vec2 uv)
{
    return texture(worldTexture, uv);
}

// Get map layer color
vec4 layerColor(vec2 uv, float layer)
{
    return texture(mapLayersTexture, vec3(uv, normalizedTime1() * textureSize(mapLayersTexture, 0).z));
}

// Get map color (including world texture and map layers)
vec4 mapColor(vec2 uv)
{
    vec4 color1 = worldColor(uv);
    vec4 color2 = layerColor(uv, 0);

    return vec4((1.0 - color2.a) * color1.rgb + color2.a * color2.rgb, 1.0);
}
