
#version 330


// Uniforms
uniform vec4 viewport;


// Computes pixel position on screen
vec2 clipToPixelSpace(vec4 clipCoords)
{
    vec2 posFactor = 0.5 * viewport.zw;
    return vec2(clipCoords.xy / clipCoords.w) * posFactor + posFactor;
}

// Computes distance between two clip coordinates in pixels
float pixelLength(vec4 clipStart, vec4 clipEnd)
{
    vec2 posFactor = 0.5 * viewport.zw;
    return length((clipStart.xy / clipStart.w - clipEnd.xy / clipEnd.w) * posFactor);
}

