
#version 330


////////////////////////////////////////////////////////////////////////////////////////////////////
// Uniforms
////////////////////////////////////////////////////////////////////////////////////////////////////

// Temporal filtering
uniform vec2 timeSpan;
uniform vec2 timeSpan1;
uniform vec2 timeSpan2;
uniform vec2 timeSpan3;
uniform vec2 timeSpan4;


////////////////////////////////////////////////////////////////////////////////////////////////////
// Temporal filtering
////////////////////////////////////////////////////////////////////////////////////////////////////

float normalizedTime1()
{
    return (timeSpan1.x - timeSpan.x) / (timeSpan.y - timeSpan.x);
}

float normalizedTime2()
{
    return (timeSpan2.x - timeSpan.x) / (timeSpan.y - timeSpan.x);
}

float normalizedTime3()
{
    return (timeSpan3.x - timeSpan.x) / (timeSpan.y - timeSpan.x);
}

float normalizedTime4()
{
    return (timeSpan4.x - timeSpan.x) / (timeSpan.y - timeSpan.x);
}

bool filterTimeSpan1(float time)
{
    return (time < timeSpan1.x || time > timeSpan1.y);
}

bool filterTimeSpan2(float time)
{
    return (time < timeSpan2.x || time > timeSpan2.y);
}

bool filterTimeSpan3(float time)
{
    return (time < timeSpan3.x || time > timeSpan3.y);
}

bool filterTimeSpan4(float time)
{
    return (time < timeSpan4.x || time > timeSpan4.y);
}

float filterTemporal(float time)
{
    bool filtered = filterTimeSpan1(time) || filterTimeSpan2(time) || filterTimeSpan3(time) || filterTimeSpan4(time);
    if (filtered) return 0.0;
    else          return 1.0;
}
