
#version 330


////////////////////////////////////////////////////////////////////////////////////////////////////
// Input from geometry shader
////////////////////////////////////////////////////////////////////////////////////////////////////

in float g_density1;
in float g_density2;
in float g_density3;
in float g_pos;


////////////////////////////////////////////////////////////////////////////////////////////////////
// Output to frame buffer
////////////////////////////////////////////////////////////////////////////////////////////////////

layout (location = 0) out vec4 density;


////////////////////////////////////////////////////////////////////////////////////////////////////
// Fragment shader
////////////////////////////////////////////////////////////////////////////////////////////////////

void main(void)
{
    float d3 = (1.0 - abs(g_pos)) * g_density1;
    float d1 = (1.0 - abs(g_pos)) * g_density2;
    float d2 = (1.0 - abs(g_pos)) * g_density3;
    density = vec4(d1, d2, d3, 0.03);
}
