
#version 330


////////////////////////////////////////////////////////////////////////////////////////////////////
// Uniforms
////////////////////////////////////////////////////////////////////////////////////////////////////

uniform sampler2D overlayColor;


////////////////////////////////////////////////////////////////////////////////////////////////////
// Input from vertex shader
////////////////////////////////////////////////////////////////////////////////////////////////////

in vec2 v_uv; // Texture coordinates


////////////////////////////////////////////////////////////////////////////////////////////////////
// Output to frame buffer
////////////////////////////////////////////////////////////////////////////////////////////////////

layout (location = 0) out vec4 color;


////////////////////////////////////////////////////////////////////////////////////////////////////
// Fragment shader
////////////////////////////////////////////////////////////////////////////////////////////////////

void main()
{
    float d1 = texture(overlayColor, v_uv).r;
    float d2 = texture(overlayColor, v_uv).g;
    float d3 = texture(overlayColor, v_uv).b;
    color = vec4(d1, d2, d3, max(d1, max(d2, d3)));
}
