
#version 330


////////////////////////////////////////////////////////////////////////////////////////////////////
// Uniforms
////////////////////////////////////////////////////////////////////////////////////////////////////

// Options
uniform float widthScale = 1.0;


////////////////////////////////////////////////////////////////////////////////////////////////////
// Input from geometry shader
////////////////////////////////////////////////////////////////////////////////////////////////////

flat          in int   g_edgeId;    // Edge ID
noperspective in vec2  g_screenpos; // Position (screen space)
              in float g_width;     // Edge width (0..1)
              in vec4  g_color;     // Edge color


////////////////////////////////////////////////////////////////////////////////////////////////////
// Output to frame buffer
////////////////////////////////////////////////////////////////////////////////////////////////////

layout (location = 0) out vec4 color;


////////////////////////////////////////////////////////////////////////////////////////////////////
// Fragment shader
////////////////////////////////////////////////////////////////////////////////////////////////////

void main()
{
    // Get edge attributes width and color
    float w = (0.5 + g_width * 4.5) * widthScale;

    // Calculate distance of fragment to line center
    vec2 dCoord = g_screenpos - gl_FragCoord.xy;
    float dist2 = dot(dCoord, dCoord);
    if (dist2 > w*w) {
        // Discard pixel, when it is too far away from line center (resp. to line width)
        discard;
    }

    // gl_FragDepth -= 0.01;

    // Set color
    color = g_color;
}
