
#version 140
#extension GL_ARB_explicit_attrib_location : require


////////////////////////////////////////////////////////////////////////////////////////////////////
// Uniforms
////////////////////////////////////////////////////////////////////////////////////////////////////

uniform vec4  viewport;
uniform float plotMarginX = 16.0;
uniform float plotMarginY = 54.0;
uniform float plotMarginHeight = 300.0;


////////////////////////////////////////////////////////////////////////////////////////////////////
// Input data
////////////////////////////////////////////////////////////////////////////////////////////////////

layout (location = 0) in vec2 a_vertex;


////////////////////////////////////////////////////////////////////////////////////////////////////
// Output to fragment shader
////////////////////////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////////////////////////
// Vertex shader
////////////////////////////////////////////////////////////////////////////////////////////////////

void main()
{
    float x = (plotMarginX / viewport.z) + (a_vertex.x + 1.0) * 0.5 * (viewport.z - 2.0 * plotMarginX) / viewport.z;
    float y = (plotMarginY / viewport.w) + (a_vertex.y + 1.0) * 0.5 * plotMarginHeight / viewport.w;

    gl_Position = vec4(x * 2.0 - 1.0, y * 2.0 - 1.0, 0.0, 1.0);
}
