
#version 330


////////////////////////////////////////////////////////////////////////////////////////////////////
// Uniforms
////////////////////////////////////////////////////////////////////////////////////////////////////

uniform vec4  viewport;
uniform float plotMarginX = 16.0;
uniform float plotMarginY = 54.0;
uniform float plotMarginHeight = 300.0;
uniform vec4  color = vec4(0.0, 1.0, 0.0, 1.0);


////////////////////////////////////////////////////////////////////////////////////////////////////
// Input data
////////////////////////////////////////////////////////////////////////////////////////////////////

// Vertex (x / y / id / - ) in [0..1]
layout (location = 0) in vec4 vertex;


////////////////////////////////////////////////////////////////////////////////////////////////////
// Output to geometry shader
////////////////////////////////////////////////////////////////////////////////////////////////////

out vec4 v_color; // Plot color


////////////////////////////////////////////////////////////////////////////////////////////////////
// Imported functions
////////////////////////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////////////////////////
// Vertex shader
////////////////////////////////////////////////////////////////////////////////////////////////////

void main(void)
{
    float x = plotMarginX + vertex.x * (viewport.z - 2.0 * plotMarginX);
    float y = plotMarginY + vertex.y * plotMarginHeight;

    gl_Position = vec4((x / viewport.z) * 2.0 - 1.0, (y / viewport.w) * 2.0 - 1.0, 0.0, 1.0);
    v_color     = color;
}
