
#version 330


// Definitions
#define PI 3.14159265359
#define E  2.71828182846


// Input
in vec2 v_uv;


// Output
layout (location = 0) out vec4 color;


// Imported functions
vec4 mapColor(vec2 uv);


void main(void)
{
    vec2 uv = v_uv * 2.0;

    float len = length(uv);
    float angle = atan(uv.y, uv.x) + 1.5*PI;

    if (len > 1.0)
        discard;

    // Find out texcoords
    float texV = 1.0 - len;
    float texU = angle / (PI*2);

    if (texU <  0.0) texU += 1.0;
    if (texU >= 1.0) texU -= 1.0;
    if (texV <  0.0) texV += 1.0;
    if (texV >= 1.0) texV -= 1.0;

    // Set color
    color = mapColor(vec2(texU, texV));
}
