
#version 330


// Definitions
#define PI 3.14159265359
#define E  2.71828182846


// Input
in vec2 v_uv;


// Output
layout (location = 0) out vec4 color;


// Imported functions
vec4 mapColor(vec2 uv);


void main(void)
{
    vec2 uv;

    // Get position
    float x = v_uv.x * 0.5 + 0.5; // (-1.0 .. 1.0) -> (0.0 .. 1.0)
    float y = v_uv.y + 0.5;       // (-0.5 .. 0.5) -> (0.0 .. 1.0)

    // Inverse mercator projection
    /*
    uv.x = 2 * atan(pow(E, x)) - 0.5 * PI;
    uv.y = y;
    */

    // Direct mapping
    uv.x = x;
    uv.y = y;

    // Texture lookup
    color = mapColor(uv);
}
