
#version 330


#define PI 3.14159265359


uniform float projectionRadius360Deg = 0.5;
uniform float heightScale  = 1.0;
uniform float heightOffset = 0.0;


// Convert Lat/Long/Height coordinate to absolute coordinates
vec4 fromLatLon(vec3 latLongHeight)
{
    float r = projectionRadius360Deg * (0.5 - latLongHeight.x / PI);
    float x =  sin(latLongHeight.y) * r;
    float y = -cos(latLongHeight.y) * r;
    return vec4(x, y, (latLongHeight.z + heightOffset) * heightScale, 1.0);
}

// Move the given absolute coordinate to the earth surface
vec3 correctHeight(vec3 absolutePos, float heightDelta)
{
    absolutePos.z += heightDelta * heightScale;
    return absolutePos;
}
