
#version 140
#extension GL_ARB_explicit_attrib_location : require


// Definitions
const float PI = 3.141592654;


// Input
in vec3 v_worldCoord;


// Output
layout (location = 0) out vec4 color;


// Imported functions
vec4 mapColor(vec2 uv);


void main()
{
    float ofs = 0.5;

    vec3 normal = normalize(v_worldCoord);
    vec2 uv = vec2(
                ofs - (atan(normal.z, normal.x) / (2.0 * PI)),
                asin(normal.y) / PI + ofs
              );

    color = mapColor(uv);
}
