
#pragma once


namespace gtx
{


template <typename T> DataStream & DataStream::read(T & i)
{
    if (has(sizeof(T)) && DataStream::Ok == m_status) {
        T result = *reinterpret_cast<const T*>(&(*m_data)[m_idx]);
        m_idx += sizeof(T);
        if (m_byteOrder != m_systemOrder) {
            T tmp = 0;
            for (uint8_t i = 0; i < sizeof(T); ++i) {
                tmp = (tmp << 8) | (result & 0xFF);
                result = result >> 8;
            }
            i = tmp;
        } else
            i = result;
    } else {
        m_status = ReadPastEnd;
    }

    return *this;
}


} // namespace gtx
