
#include <gtxlib-core/base/Position.h>


namespace gtx
{


Position Position::LatLong(float latitude, float longitude, float height)
{
    return Position(latitude, longitude, height);
}


Position::Position()
{
}

Position::Position(float x, float y, float z) : glm::vec3(x, y, z)
{
}

Position::Position(const glm::vec3 & v) : glm::vec3(v)
{
}

Position::Position(const Position & position) : glm::vec3(position.x, position.y, position.z)
{
}

Position::~Position()
{
}

float Position::getLat() const
{
    return x;
}

void Position::setLat(float latitude)
{
    x = latitude;
}

float Position::getLong() const
{
    return y;
}

void Position::setLong(float longitude)
{
    y = longitude;
}

float Position::getHeight() const
{
    return z;
}

void Position::setHeight(float height)
{
    z = height;
}


} // namespace gtx
