
#include <gtxlib-core/data/AbstractItemGroup.h>

#include <cppassist/memory/make_unique.h>


namespace gtx
{


AbstractItemGroup::AbstractItemGroup()
{
}

AbstractItemGroup::~AbstractItemGroup()
{
}

const std::vector<std::string> & AbstractItemGroup::attributes() const
{
    return m_names;
}

const AttributeInfo * AbstractItemGroup::attribute(const std::string & name) const
{
    auto it = m_attributes.find(name);
    if (it != m_attributes.end())
    {
        return it->second.get();
    }

    return nullptr;
}

AttributeInfo * AbstractItemGroup::attribute(const std::string & name)
{
    AttributeInfo * attribute = nullptr;

    auto it = m_attributes.find(name);
    if (it != m_attributes.end())
    {
        attribute = it->second.get();
    }

    if (!attribute)
    {
        auto ptr = cppassist::make_unique<AttributeInfo>(name);
        attribute = ptr.get();

        m_attributes[name] = std::move(ptr);
        m_names.push_back(name);
    }

    return attribute;
}


} // namespace gtx
