
#include <gtxlib-core/data/Edge.h>

#include <gtxlib-core/data/Node.h>


namespace gtx
{


Edge::Edge(id_t id)
: Item(id)
, m_node1(nullptr)
, m_node2(nullptr)
{
}

Edge::~Edge()
{
}

Node * Edge::node1() const
{
    return m_node1;
}

void Edge::setNode1(Node * node)
{
    m_node1 = node;
}

Node * Edge::node2() const
{
    return m_node2;
}

void Edge::setNode2(Node * node)
{
    m_node2 = node;
}

Position Edge::startPos() const
{
    if (m_node1) return m_node1->position();
    else         return Position();
}

Position Edge::endPos() const
{
    if (m_node2) return m_node2->position();
    else         return Position();
}


} // namespace gtx
