
#include <gtxlib-core/data/Line.h>

#include <gtxlib-core/data/Node.h>


namespace gtx
{


Line::Line(id_t id)
: Item(id)
{
}

Line::~Line()
{
}

void Line::clear()
{
    m_nodes.clear();
}

size_t Line::numNodes() const
{
    return m_nodes.size();
}

const std::vector<Node *> & Line::nodes() const
{
    return m_nodes;
}

std::vector<Node *> & Line::nodes()
{
    return m_nodes;
}

const Node * Line::node(size_t index) const
{
    if (index < m_nodes.size())
    {
        return m_nodes[index];
    }

    return nullptr;
}

Node * Line::node(size_t index)
{
    if (index < m_nodes.size())
    {
        return m_nodes[index];
    }

    return nullptr;
}

void Line::add(Node * node)
{
    if (node)
    {
        m_nodes.push_back(node);
    }
}


} // namespace gtx
