
#include <gtxlib-core/data/Node.h>

#include <gtxlib-core/base/Time.h>


namespace gtx
{


Node::Node(id_t id)
: Item(id)
, m_edgeId(null_id)
, m_timeInt(0)
{
}

Node::~Node()
{
}

id_t Node::edgeId() const
{
    return m_edgeId;
}

void Node::setEdgeId(id_t id)
{
    m_edgeId = id;
}

const Position & Node::position() const
{
    return m_position;
}

void Node::setPosition(const Position & pos)
{
    m_position = pos;
}

time_point Node::time() const
{
    return m_time;
}

void Node::setTime(time_point time)
{
    m_time    = time;
    m_timeInt = Time::toInt(time);
}

unsigned long Node::timeInt() const
{
    return m_timeInt;
}


} // namespace gtx
