
#include <gtxlib-core/geometry/PatchGeometry.h>

#include <gtxlib-core/geometry/NodeGeometry.h>


namespace gtx
{


PatchGeometry::PatchGeometry()
: m_nodeGeometry(nullptr)
{
}

PatchGeometry::~PatchGeometry()
{
}

NodeGeometry * PatchGeometry::nodeGeometry() const
{
    return m_nodeGeometry;
}

void PatchGeometry::setNodeGeometry(NodeGeometry * nodeGeometry)
{
    m_nodeGeometry = nodeGeometry;
}

unsigned int PatchGeometry::numElements() const
{
    if (m_nodeGeometry)
        return m_nodeGeometry->numElements();
    else
        return 0;
}

unsigned int PatchGeometry::size() const
{
    if (m_nodeGeometry)
        return m_nodeGeometry->size();
    else
        return 0;
}

globjects::VertexArray * PatchGeometry::vao()
{
    if (m_nodeGeometry)
        return m_nodeGeometry->vao();
    else
        return nullptr;
}

const globjects::VertexArray * PatchGeometry::vao() const
{
    if (m_nodeGeometry)
        return m_nodeGeometry->vao();
    else
        return nullptr;
}

void PatchGeometry::draw() const
{
    if (m_nodeGeometry)
    {
        m_nodeGeometry->drawPatches();
    }
}


} // namespace gtx
