
#include <gtxlib-core/gtxlib-core.h>

#include <cpplocate/cpplocate.h>


namespace
{


std::string determineDataPath()
{
    std::string path = cpplocate::locatePath("data/gtx/textures/world.png", "share/gtx", reinterpret_cast<void *>(&gtx::dataPath));
    if (path.empty()) path = "./data/gtx";
    else              path = path + "/data/gtx";

    return path;
}

std::string determineDatasetPath()
{
    std::string path = cpplocate::locatePath("datasets/ds1.dot", "share/gtx", reinterpret_cast<void *>(&gtx::dataPath));
    if (path.empty()) path = "./datasets";
    else              path = path + "/datasets";

    return path;
}


} // namespace


namespace gtx
{


const std::string & dataPath()
{
    static const auto path = determineDataPath();

    return path;
}

const std::string & datasetPath()
{
    static const auto path = determineDatasetPath();

    return path;
}


} // namespace gtx
