
#include <gtxlib-stages/DataLoaderStage.h>

#include <gloperate/base/Environment.h>
#include <gloperate/base/ResourceManager.h>

#include <gtxlib-core/data/DataSet.h>


namespace gtx
{


CPPEXPOSE_COMPONENT(DataLoaderStage, gloperate::Stage)


DataLoaderStage::DataLoaderStage(gloperate::Environment * environment, const std::string & name)
: gloperate::Stage(environment, "DataLoaderStage", name)
, filePath("filePath", this)
, dataset("dataset", this)
{
}

DataLoaderStage::~DataLoaderStage()
{
}

void DataLoaderStage::onProcess()
{
    std::string filename = (*filePath).path();

    m_dataset = std::unique_ptr<gtx::DataSet>(environment()->resourceManager()->load<gtx::DataSet>(filename));
    if (m_dataset) {
        m_dataset->setFilename(filename);

        m_dataset->calculateAttributeStatistics();
        //m_dataset->printStatistics();
    }

    dataset.setValue(m_dataset.get());
}


} // namespace gtx
