
#include <gtxlib-stages/MappingStage.h>


namespace gtx
{


CPPEXPOSE_COMPONENT(MappingStage, gloperate::Stage)


MappingStage::MappingStage(gloperate::Environment * environment, const std::string & name)
: gloperate::Stage(environment, "MappingStage", name)
, attributes("attributes", this)
, nodeColor("nodeColor", this)
, nodeSize("nodeSize", this)
, nodeHeight("nodeHeight", this)
, edgeColor("edgeColor", this)
, edgeWidth("edgeWidth", this)
, lineColor("lineColor", this)
, lineWidth("lineWidth", this)
, primaryAttribute("primaryAttribute", this)
, nodeColorIndex("nodeColorIndex", this)
, nodeSizeIndex("nodeSizeIndex", this)
, nodeHeightIndex("nodeHeightIndex", this)
, edgeColorIndex("edgeColorIndex", this)
, edgeWidthIndex("edgeWidthIndex", this)
, lineColorIndex("lineColorIndex", this)
, lineWidthIndex("lineWidthIndex", this)
, primaryAttributeIndex("primaryAttributeIndex", this)
{
}

MappingStage::~MappingStage()
{
}

void MappingStage::onProcess()
{
    int index = 0;

    index = getAttributeIndex(*nodeColor);
    if (*nodeColorIndex != index) nodeColorIndex.setValue(index);

    index = getAttributeIndex(*nodeSize);
    if (*nodeSizeIndex != index) nodeSizeIndex.setValue(index);

    index = getAttributeIndex(*nodeHeight);
    if (*nodeHeightIndex != index) nodeHeightIndex.setValue(index);

    index = getAttributeIndex(*edgeColor);
    if (*edgeColorIndex != index) edgeColorIndex.setValue(index);

    index = getAttributeIndex(*edgeWidth);
    if (*edgeWidthIndex != index) edgeWidthIndex.setValue(index);

    index = getAttributeIndex(*lineColor);
    if (*lineColorIndex != index) lineColorIndex.setValue(index);

    index = getAttributeIndex(*lineWidth);
    if (*lineWidthIndex != index) lineWidthIndex.setValue(index);

    index = getAttributeIndex(*primaryAttribute);
    if (*primaryAttributeIndex != index) primaryAttributeIndex.setValue(index);
}

int MappingStage::getAttributeIndex(const std::string & attribute) const
{
    const std::vector<std::string> & values = *attributes;
    auto it = std::find(values.begin(), values.end(), attribute);

    if (it != values.end()) {
        return std::distance(values.begin(), it);
    } else {
        return -1;
    }
}


} // namespace gtx
