
#include <gtxlib-stages/ScreenshotStage.h>

#include <glbinding/gl/enum.h>

#include <globjects/Texture.h>

#include <gloperate/base/Environment.h>
#include <gloperate/base/ResourceManager.h>
#include <gloperate/rendering/ColorRenderTarget.h>


using namespace cppexpose;


namespace gtx
{


CPPEXPOSE_COMPONENT(ScreenshotStage, gloperate::Stage)


ScreenshotStage::ScreenshotStage(gloperate::Environment * environment, const std::string & name)
: gloperate::Stage(environment, "ScreenshotStage", name)
, colorTarget("colorTarget", this)
, path("path", this, "")
, colorTargetOut("colorTargetOut", this)
{
}

ScreenshotStage::~ScreenshotStage()
{
}

void ScreenshotStage::onProcess()
{
    // Get texture from render target
    auto * texture = colorTarget->textureAttachment();
    if (texture) {
        // Check output filename
        std::string filename = *path;
        if (filename != "") {
            // Save screenshot
            environment()->resourceManager()->store<globjects::Texture>(filename, texture);

            // Reset filename
            path = "";
        }
    }

    // Pass-through render target
    colorTargetOut.setValue(colorTarget.value());
}


} // namespace gtx
